import requests
import random
import time
from datetime import datetime
import json
import sys
import psycopg2
from elasticsearch import RequestsHttpConnection
from elasticsearch import Elasticsearch
from elasticsearch import helpers
url="http://localhost"
print("=======================================================================================================================================================================================")
_date=datetime.now()
print(_date)
debug=True
try:
	result=requests.get(url+'/api/systems/details')
except Exception as e:
	print(e)

if(result.ok):
	result_json=result.json()
	asset_tag=result_json['appliance']['asset_tag']
	name=result_json['appliance']['name']
	version=result_json['appliance']['version']
if(not asset_tag):
	raise Exception("Ueb-Login invalid API response")

def generate_token():
	global cluster
	try:
		with open('/settings.txt','r') as settings_file:
			flag=settings_file.read()
			print("Flag from Settings file is: "+flag)
	except:
		flag="0"
		print("Connecting to Prod")	
	#print(id(flag.strip()))
	#print(id("cluster=1".strip()))
	if(flag.strip()=="cluster=1"):
		cluster="Dev"
		url="https://186d3db611b64f1384e09d6c82d564da.us-east-1.aws.found.io/_xpack/security/oauth2/token"
		head={"Authorization": "Basic ZWxhc3RpYzpGN1dOMTVqbUt4UTU0Wno4NjFoc1NhSWg=","Content-Type": "application/json"}
	else:
		cluster="Prod"	
		url="https://1822f510d5b0459f96be33df425d8a09.us-east-1.aws.found.io/_xpack/security/oauth2/token"
		head={"Authorization": "Basic ZWxhc3RpYzpqeUVkSEw1OUZ4eWhYN3Q5dmtWdmgzMGw=","Content-Type": "application/json"}
	req_body={"grant_type":"password",
	"username":"elkcollect",
	"password": "unitrends1"}
	data_json=json.dumps(req_body)
	result=requests.post(url,data=data_json,headers=head)
	print(result)
	if(result.ok):
		print(cluster+" : "+result.json()['access_token'])
		return result.json()['access_token']

def DebugConsole(obj,method):
	print("ERROR: "+method)
	if(debug):
		#print("Index Result: "+ str(index_result))
		print("Obj: "+str(obj));

def UebLogin():
	token=generate_token()
	#token="t7/yAiCmpoNO8OlkdxdhV7IZJx8oj++EOgHcB8lZO7EiPsJUVghYN2UguGw5ygykiCSolPk+zYeo5fDbzl1d8LBwxiCiKQoUAoYUBR6BTezZfxIhwc9ADKXRu4mJBkLW37w="
	if(cluster.strip()=="Prod"):
		host="https://1822f510d5b0459f96be33df425d8a09.us-east-1.aws.found.io"
	else:
		host="https://186d3db611b64f1384e09d6c82d564da.us-east-1.aws.found.io"
	head={'Authorization': 'Bearer %s'% token }
	print(host)
	es=Elasticsearch(host,headers=head,connection_class=RequestsHttpConnection)
	print(es.ping())
	#es=Elasticsearch(url,http_auth=(username,password),port=443)
	if(not es.ping()):
		print(es)
		print(es.ping())
		raise ValueError("****************************Could not connect to Elk CLoud*********************")
		sys.exit(1)
	else:
		return es
	
def IndexAssets(es):
	result=requests.get(url+'/api/assets/?sid=1')
	if(result.ok):
		result_json=result.json()
		if('data' in result_json):
			for asset in result_json['data']:
				o={}
				o['timestamp']=_date
				o['asset_tag']=asset_tag
				o['asset_type']=asset['asset_type']
				o['instance_id']=str(asset['id'])
				o['name']=asset['name']
				print(o)
				if(asset['asset_type']=="physical"):
					o['os_family']=asset['os_family']
					o['os_type']=asset['os_type']
					if(asset['min_max_policy'] is not None):
						o['retention_max']=asset['min_max_policy']['retention_max']
						o['retention_min']=asset['min_max_policy']['retention_min']
				elif(asset['asset_type']=="VMware Host"):
					o['os_family']=asset['type']
					o['os_type']=asset['type']
				if(not es.ping()):
					es=UebLogin()
				#es=UebLogin()
				try:
					index_result=es.index(index="ueb-assets-"+_date.strftime("%Y.%m"),doc_type="object",id=asset_tag+"_"+o['instance_id'],body=o)
					print(index_result['result'])
				except Exception as es1:
					print(es1)
					DebugConsole(o,"IndexAssets")
				#print(index_result['result'])	
				

def IndexMetricBackupCapacity(es):
	result=requests.get(url+'/api/reports/system/capacity/?sid=1')
	if(result.ok):
		result_json=result.json()
		if( 'data' in result_json):
			if(len(result_json['data']) >0):
				o={}
				o['type']="capacity"
				o['asset_tag']=asset_tag
				o['timestamp']=_date
				o['capacity']={}
				o['capacity']['ir_used']=result_json['data'][0]['ir_used']
				o['capacity']['used']=result_json['data'][0]['used']
				o['capacity']['available']=result_json['data'][0]['available']
				try:
					o['capacity']['percent_used']=(100*(o['capacity']['used']+o['capacity']['ir_used']))/o['capacity']['available']
				except ZeroDivisionError as e:
					print(e)
				#print(o)
				if(not es.ping()):
					es=UebLogin()
				#es=UebLogin()
				try:
					index_result=es.index(index="ueb-metrics-"+_date.strftime("%Y.%m"),doc_type="object",id=asset_tag+"_capacity_"+_date.strftime("%Y.%m.%d_%H.%M"),body=o)
					print(index_result['result'])
				except Exception as es1:
					print(es1)
					DebugConsole(o,"IndexMetricBackupCapacity")
				#print(index_result['result'])

def IndexMetricStorage(es):
	result=requests.get(url+'/api/storage')	
	print("[" +str(datetime.now())+ "] Indexing storages on ELK......")
	if(result.ok):
		result_json=result.json()
		if('storage' in result_json):
			for s in result_json['storage']:
				o={}
				o['type']="storage"
				o['asset_tag']=asset_tag
				o['timestamp']=_date
				o['storage']={}
				o['storage']['name']=s['name']
				o['storage']['usage']=s['usage']
				o['storage']['mb_free']=s['mb_free']
				o['storage']['mb_size']=s['mb_size']
				o['storage']['mb_used']=s['mb_size']-s['mb_free']
				o['storage']['mb_to_purge']=s['mb_to_purge']
				o['storage']['percent_used']=float(s['percent_used'].replace("%",""))
				o['storage']['type']=s['type']
				if('N/A' not in s['dedup']):
					o['storage']['dedup']=float(s['dedup'].strip().split(':')[0])
				print("")
				#print(o)
				if(not es.ping()):
					es=UebLogin()
				try:
					index_result=es.index(index="ueb-metrics-"+_date.strftime("%Y.%m"),doc_type="object",id=asset_tag+"_storage_"+_date.strftime("%Y.%m.%d_%H.%M"),body=o)
					print(index_result['result'])
				except Exception as es1:
					print(es1)
					DebugConsole(o,"IndexMetricStorage")
				#print(index_result['result'])
				


def IndexMetricConfigurableArchiveMedia(es):
	result=requests.get(url+'/api/archive/media/configurable')
	print("[" +str(datetime.now())+ "] Indexing backup copy targets configurable media on ELK......")
	if(result.ok):
		result_json=result.json()
		if('data' in result_json):
			for s in result_json['data']:
				o={}
				o['type']="backup_copy_media"
				o['asset_tag']=asset_tag
				o['timestamp']=_date
				o['target']={}
				o['target']=s
				#print(o)
				if(not es.ping()):
					es=UebLogin()
				try:
					index_result=es.index(index="ueb-metrics-"+_date.strftime("%Y.%m"),doc_type="object",id=asset_tag+"_backup_copy_media_"+o['target']['serial'],body=o)
					print(index_result['result'])
				except Exception as es1:
					print(es1)
					DebugConsole(o,"IndexMetricConfigurableArchiveMedia")
				#print(index_result['result'])



def IndexMetricBackupCopyTargets(es):
	result=requests.get(url+'/api/backup-copy/targets')
	print("[" +str(datetime.now())+ "] Indexing backup copy targets on ELK......")
	if(result.ok):
		result_json=result.json()
		if('data' in result_json):
			for s in result_json['data'][0]['targets']:
				o={}
				o['type']="backup_copy_target"
				o['asset_tag']=asset_tag
				o['timestamp']=_date
				o['target']={}
				o['target']=s
				#print(type(s))
				if(not es.ping()):
					es=UebLogin()
				try:
					index_result=es.index(index="ueb-metrics-"+_date.strftime("%Y.%m"),doc_type="object",id=asset_tag+"_backup_copy_target_"+o['target']['id']+"_"+_date.strftime("%Y.%m.%d_%H.%M"),body=o)
					print(index_result['result'])
				except Exception as es1:
					print(es1)
					DebugConsole(o,"IndexMetricBackupCopyTargets")
				#print(index_result['result'])

	

def IndexMetricBackupCopyCapacity(es):
	result=requests.get(url+'/api/reports/replication/capacity/?sid=1')
	print("[" +str(datetime.now())+ "] Indexing backup copy capacity on ELK......")
	if(result.ok):
		result_json=result.json()
		if('data' in result_json):
			for source in result_json['data']:
				o={}
				o['type']="backupcopy_capacity"
				o['asset_tag']=asset_tag
				o['name']=name
				o['timestamp']=_date
				o['backupcopy_capacity']={}
				o['backupcopy_capacity']['used_gb']=source['size']/1024
				o['backupcopy_capacity']['source_system']=source['system_name']
				query="SELECT asset_tag FROM bp.target_replication_config WHERE hostname='"+source['system_name'].strip()+"'"
				query_result=QuerySql("source_asset_tag",query,"bpdb",True)
				#print(query_result)
				if query_result:
					print(query_result[0]['source_asset_tag']['asset_tag'])
					o['backupcopy_capacity']['source_asset_tag']=query_result[0]['source_asset_tag']['asset_tag']
				#print(o)
				if(not es.ping()):
					es=UebLogin()
				try:
					index_result=es.index(index="ueb-metrics-"+_date.strftime("%Y.%m"),doc_type="object",id=asset_tag+"_backupcopy_capacity_"+source['system_name']+"_"+_date.strftime("%Y.%m.%d_%H.%M"),body=o)
					print(index_result['result'])
				except Exception as es1:
					print(es1)
					DebugConsole(o,"IndexMetricBackupCopyCapacity")
				


def IndexMetricSqlAsDoc(es,query_name,db,sql,select_json=True):
	print("["+str(datetime.now())+"] Indexing psql query....................")
	query_result=QuerySql(query_name,sql,"bpdb",True)
	if(len(query_result)>0):
		index="ueb-metrics-"+_date.strftime("%Y.%m")
		actions=[]
		for s in query_result:
			id=s['asset_tag']+"_"+str(s['replication']['backup_no'])+"_"+str(s['replication']['done_epoch'])
			body={"_index": index,"_op_type": "index","_id": id,"_source": s,"_type":"object"}
			actions.append(body)
		#print(actions)
		if(not es.ping()):
			es=UebLogin()
		try:
			index_result=helpers.bulk(es,actions)
			print(index_result)
		except Exception as es1:
			print(es1)
			DebugConsole(actions,"IndexMetricSqlAsDoc")
		#print(index_result)	
	





def QuerySql(query_name,query,db_name,select_json):
	user="postgres"
	server="localhost"
	content=[]
	if(select_json):
		query="select row_to_json(t) from("+query+")t"
	connection=psycopg2.connect(host=server,user=user,dbname=db_name)
	cur=connection.cursor()
	cur.execute(query)
	rows=cur.fetchall()
	for row in rows:
		row_json=json.dumps(row[0])
		temp_dict=json.loads(row_json)
		data={}
		data[query_name]=temp_dict
		data['asset_tag']=asset_tag
		data['type']=query_name
		if "start_time" in temp_dict:
			data['timestamp']=temp_dict['start_time'].replace(" ","T")
		content.append(data)
	return content



random_number=random.randint(0,60*30)
print("[*] Waiting "+str(random_number)+" seconds before starting...")
time.sleep(random_number)
es=UebLogin()
IndexAssets(es)
IndexMetricBackupCapacity(es)
IndexMetricStorage(es)
IndexMetricBackupCopyTargets(es)
IndexMetricConfigurableArchiveMedia(es)
#query="SELECT install_id, name, role FROM bp.state, bp.systems WHERE is_local_system = true"
#QuerySql("find_asset_tag",query,"bpdb",True)
IndexMetricBackupCopyCapacity(es)
IndexMetricSqlAsDoc(es,"replication","bpdb","select stat_time as start_time,* from bp.sds_stats where stat_time >=NOW() - '1 day'::INTERVAL")


